! 
! $Id: checkoutput.f90,v 1.1.1.1 1999/08/18 12:59:11 gvacanti Exp $
! 

 ! ====================================================================
program checkRGSWavelengthOutput
  ! ====================================================================

  use dal
  use saslib
  use odfnames

  implicit none 

  type(DataSetT)                  :: inset
  type(TableT)                    :: tbl
  real (single),      pointer      :: mlambda(:)
  character (len=100)             :: file
  character (len=*)  , parameter  :: fn = 'checkRGSWavelengthOutput :'

  file = 'eventlist.ds'      ! hardcoded filename
  write(*,*) 'Testing file : ', file
  write(*,*) 'Warning this test depends on the values in the calibration files.'

  ! --------------------------------------------------------------
  !  read back some of the data and compare with hard coded values
  ! --------------------------------------------------------------

  inset = dataSet(file, read)

  tbl = table(inSet, RGS_EVENTS_TABLE_NAME )

  write(*,*) ' Checking values table: ', name(tbl)

  mlambda  =>  real32Data(Column(tbl, M_LAMBDA_COLUMN_NAME , read))

  ! check first 4  values against hardcoded.
  notNear_epsilon = 1.e-5

!!$  These were using the dummy detector coordinate conversion as calculated in rgsenergy
!!$  if (notNear(mlambda(0), -3.16778 ))  call error('first mlambda  values wrong')
!!$  if (notNear(mlambda(1), -3.23849 ))  call error('2nd mlambda  values wrong')
!!$  if (notNear(mlambda(2), -3.24507 ))  call error('3rd mlambda  values wrong')
!!$  if (notNear(mlambda(3), -3.07710 ))  call error('4th mlambda  values wrong')

!! These values resulted doing the CAL_rawxy2mm call in rgsenergy.

  if (notNear(mlambda(0), -3.36036 ))  call error('first mlambda  values wrong')
  if (notNear(mlambda(1), -3.38435 ))  call error('2nd mlambda  values wrong')
  if (notNear(mlambda(2), -3.38658 ))  call error('3rd mlambda  values wrong')
  if (notNear(mlambda(3), -3.32936 ))  call error('4th mlambda  values wrong')

  call release (tbl)
  call release (inSet)

end program 


